=== modified file 'NEWS'
--- NEWS	2008-11-28 06:31:17 +0000
+++ NEWS	2008-11-29 02:01:21 +0000
@@ -16,6 +16,10 @@
 
   BUG FIXES:
 
+    * Fix SystemError in ``_patiencediff_c`` module by calling
+      PyErr_NoMemory() before returning NULL in PatienceSequenceMatcher_new.
+      (Andrew Bennetts, #303206)
+
   DOCUMENTATION:
 
   API CHANGES:

=== modified file 'bzrlib/_patiencediff_c.c'
--- bzrlib/_patiencediff_c.c	2008-09-25 22:08:41 +0000
+++ bzrlib/_patiencediff_c.c	2008-11-29 00:31:13 +0000
@@ -768,6 +768,7 @@
         self->backpointers = (Py_ssize_t *)malloc(sizeof(Py_ssize_t) * self->bsize * 4);
         if (self->backpointers == NULL) {
             Py_DECREF(self);
+            PyErr_NoMemory();
             return NULL;
         }
 

